Loading...
Searching...
No Matches
pappso::PeptideRawFragmentMasses Class Reference

`#include <peptiderawfragmentmasses.h>`

## Public Member Functions

| PeptideRawFragmentMasses (const Peptide &peptide, RawFragmentationMode mode)
| ~PeptideRawFragmentMasses ()
void | pushBackIonMasses (std::vector< pappso_double > &mass_list, Enums::PeptideIon ion_type) const
void | pushBackIonMz (std::vector< pappso_double > &mass_list, Enums::PeptideIon ion_type, unsigned int charge) const
void | pushBackMatchSpectrum (std::vector< SimplePeakIonMatch > &peak_match_list, const MassSpectrum &spectrum, PrecisionPtr precision, Enums::PeptideIon ion_type, unsigned int charge) const

## Static Public Member Functions

static pappso_double | getDeltaMass (Enums::PeptideIon ion_type)

## Private Types

using | ionDeltatMzMassMap = pappso_double[20]

## Private Attributes

std::vector< pappso_double > | m_cumulativeNterMasses
| cumulative Nter masses (without internal Nter modification)
std::vector< pappso_double > | m_cumulativeCterMasses
| cumulative Cter masses (without internal Cter modification)

## Static Private Attributes

static ionDeltatMzMassMap | m_ionDeltaMz

## Detailed Description

Definition at line 59 of file peptiderawfragmentmasses.h.

## Member Typedef Documentation

## ionDeltatMzMassMap

using pappso::PeptideRawFragmentMasses::ionDeltatMzMassMap = pappso_double[20]

private

Definition at line 61 of file peptiderawfragmentmasses.h.

## Constructor & Destructor Documentation

## PeptideRawFragmentMasses()

pappso::PeptideRawFragmentMasses::PeptideRawFragmentMasses | ( | const Peptide & | peptide,
|  | RawFragmentationMode | mode )

Definition at line 61 of file peptiderawfragmentmasses.cpp.

{
qDebug();
std::vector<Aa>::const_iterator it(peptide.begin());
std::vector<Aa>::const_iterator end(peptide.end());
if(it == end)
return;
qDebug();
pappso_double cumulative_mass = it->getMass();
if(peptide.getNterModification() != nullptr)
{
cumulative_mass += peptide.getNterModification()->getMass();
}
qDebug();
m_cumulativeNterMasses.push_back(cumulative_mass);
it++;
if(it != end)
{
end--;
qDebug();
while(it != end)
{
qDebug() << " cumulative_mass=" << cumulative_mass;
cumulative_mass += it->getMass();
if((mode == RawFragmentationMode::proline_effect) && (it->getLetter() == 'P'))
{
}
else
{
m_cumulativeNterMasses.push_back(cumulative_mass);
}
it++;
}
}
qDebug();
std::vector<Aa>::const_reverse_iterator rit(peptide.rbegin());
std::vector<Aa>::const_reverse_iterator ritf(peptide.rbegin());
std::vector<Aa>::const_reverse_iterator rend(peptide.rend());
ritf++;
cumulative_mass = rit->getMass();
if(peptide.getCterModification() != nullptr)
{
cumulative_mass += peptide.getCterModification()->getMass();
}
if((mode == RawFragmentationMode::proline_effect) && (ritf != rend) && (ritf->getLetter() == 'P'))
{
}
else
{
m_cumulativeCterMasses.push_back(cumulative_mass);
}
qDebug();
rit++;
ritf++;
if(rit != rend)
{
rend--;
while(rit != rend)
{
cumulative_mass += rit->getMass();
if((mode == RawFragmentationMode::proline_effect) && (ritf != peptide.rend()) &&
(ritf->getLetter() == 'P'))
{
}
else
{
m_cumulativeCterMasses.push_back(cumulative_mass);
}
rit++;
ritf++;
}
}
qDebug();
}
pappso::PeptideRawFragmentMasses::m_cumulativeCterMasses
std::vector< pappso_double > m_cumulativeCterMasses
cumulative Cter masses (without internal Cter modification)
Definition peptiderawfragmentmasses.h:72
pappso::PeptideRawFragmentMasses::m_cumulativeNterMasses
std::vector< pappso_double > m_cumulativeNterMasses
cumulative Nter masses (without internal Nter modification)
Definition peptiderawfragmentmasses.h:68
pappso::pappso_double
double pappso_double
A type definition for doubles.
Definition types.h:60
pappso::RawFragmentationMode::proline_effect
@ proline_effect
Definition peptiderawfragmentmasses.h:45

References pappso::Peptide::begin(), pappso::Peptide::end(), pappso::Peptide::getCterModification(), pappso::AaModification::getMass(), pappso::Peptide::getNterModification(), m_cumulativeCterMasses, m_cumulativeNterMasses, pappso::proline_effect, pappso::Peptide::rbegin(), and pappso::Peptide::rend().

## ~PeptideRawFragmentMasses()

pappso::PeptideRawFragmentMasses::~PeptideRawFragmentMasses | ( |  | ) |

Definition at line 222 of file peptiderawfragmentmasses.cpp.

{
}

## Member Function Documentation

## getDeltaMass()

pappso_double pappso::PeptideRawFragmentMasses::getDeltaMass | ( | Enums::PeptideIon | ion_type | ) |

static

Definition at line 55 of file peptiderawfragmentmasses.cpp.

{
return m_ionDeltaMz[(std::int8_t)ion_type];
}
pappso::PeptideRawFragmentMasses::m_ionDeltaMz
static ionDeltatMzMassMap m_ionDeltaMz
Definition peptiderawfragmentmasses.h:64

References m_ionDeltaMz.

Referenced by pappso::PeptideFragmentIon::PeptideFragmentIon(), pappso::specglob::PeptideSpectrum::PeptideSpectrum(), and pappso::specglob::PeptideModel::generateTheoreticalPeaks().

## pushBackIonMasses()

void pappso::PeptideRawFragmentMasses::pushBackIonMasses | ( | std::vector< pappso_double > & | mass_list,
|  | Enums::PeptideIon | ion_type ) const

Definition at line 145 of file peptiderawfragmentmasses.cpp.

{
const std::vector<pappso_double> *p_mass_list = &m_cumulativeCterMasses;
if(peptideIonIsNter(ion_type))
{
// nter
p_mass_list = &m_cumulativeNterMasses;
}
for(pappso_double mass : *p_mass_list)
{
mass_list.push_back(mass + m_ionDeltaMz[(std::int8_t)ion_type]);
}
}
pappso::peptideIonIsNter
bool peptideIonIsNter(Enums::PeptideIon ion_type)
tells if an ion is Nter
Definition peptide.cpp:87

References m_cumulativeCterMasses, m_cumulativeNterMasses, m_ionDeltaMz, and pappso::peptideIonIsNter().

## pushBackIonMz()

void pappso::PeptideRawFragmentMasses::pushBackIonMz | ( | std::vector< pappso_double > & | mass_list,
|  | Enums::PeptideIon | ion_type,
|  | unsigned int | charge ) const

Definition at line 163 of file peptiderawfragmentmasses.cpp.

{
const std::vector<pappso_double> *p_mass_list = &m_cumulativeCterMasses;
if(peptideIonIsNter(ion_type))
{
// nter
p_mass_list = &m_cumulativeNterMasses;
}
for(pappso_double mass : *p_mass_list)
{
mass_list.push_back((mass + m_ionDeltaMz[(std::int8_t)ion_type] + (MHPLUS * charge)) /
charge);
}
}
pappso::MHPLUS
const pappso_double MHPLUS(1.007276466879)

References m_cumulativeCterMasses, m_cumulativeNterMasses, m_ionDeltaMz, pappso::MHPLUS(), and pappso::peptideIonIsNter().

Referenced by pappso::MorpheusScore::MorpheusScore(), and pushBackMatchSpectrum().

## pushBackMatchSpectrum()

void pappso::PeptideRawFragmentMasses::pushBackMatchSpectrum | ( | std::vector< SimplePeakIonMatch > & | peak_match_list,
|  | const MassSpectrum & | spectrum,
|  | PrecisionPtr | precision,
|  | Enums::PeptideIon | ion_type,
|  | unsigned int | charge ) const

Definition at line 183 of file peptiderawfragmentmasses.cpp.

{
std::vector<pappso_double> mass_list;
pushBackIonMz(mass_list, ion_type, charge);
// no need to sort
// std::sort(mass_list.begin(), mass_list.end());
std::vector<pappso_double>::iterator it_mz = mass_list.begin();
std::vector<pappso_double>::iterator it_mz_end = mass_list.end();
// scan products over each peak in spectrum :
std::vector<DataPoint>::const_iterator it_peak = spectrum.begin();
std::vector<DataPoint>::const_iterator it_peak_end = spectrum.end();
unsigned int ion_size = 1;
while((it_peak != it_peak_end) && (it_mz != it_mz_end))
{
MzRange massrange(it_peak->x, precision);
if((*it_mz) > massrange.upper())
{
it_peak++;
continue;
}
if((*it_mz) < massrange.lower())
{
it_mz++;
ion_size++;
continue;
}
peak_match_list.push_back({(*it_peak), ion_type, ion_size, charge, (*it_mz)});
it_mz++;
ion_size++;
}
}
pappso::PeptideRawFragmentMasses::pushBackIonMz
void pushBackIonMz(std::vector< pappso_double > &mass_list, Enums::PeptideIon ion_type, unsigned int charge) const
Definition peptiderawfragmentmasses.cpp:163

References pappso::MzRange::lower(), pushBackIonMz(), and pappso::MzRange::upper().

Referenced by pappso::XtandemHyperscoreBis::computeXtandemHyperscore().

## Member Data Documentation

## m_cumulativeCterMasses

std::vector<pappso_double> pappso::PeptideRawFragmentMasses::m_cumulativeCterMasses

private

cumulative Cter masses (without internal Cter modification)

Definition at line 72 of file peptiderawfragmentmasses.h.

Referenced by PeptideRawFragmentMasses(), pushBackIonMasses(), and pushBackIonMz().

## m_cumulativeNterMasses

std::vector<pappso_double> pappso::PeptideRawFragmentMasses::m_cumulativeNterMasses

private

cumulative Nter masses (without internal Nter modification)

Definition at line 68 of file peptiderawfragmentmasses.h.

Referenced by PeptideRawFragmentMasses(), pushBackIonMasses(), and pushBackIonMz().

## m_ionDeltaMz

PeptideRawFragmentMasses::ionDeltatMzMassMap pappso::PeptideRawFragmentMasses::m_ionDeltaMz

static private

Initial value:
= {
[(std::int8_t)Enums::PeptideIon::b] = 0,
[(std::int8_t)Enums::PeptideIon::bstar] = -MASSNH3,
[(std::int8_t)Enums::PeptideIon::bo] = -MASSH2O,
[(std::int8_t)Enums::PeptideIon::a] = -MASSCO,
[(std::int8_t)Enums::PeptideIon::astar] = -MASSCO - MASSNH3,
[(std::int8_t)Enums::PeptideIon::ao] = -MASSCO - MASSH2O,
[(std::int8_t)Enums::PeptideIon::bp] = -1,
[(std::int8_t)Enums::PeptideIon::c] = MASSNH3,
[(std::int8_t)Enums::PeptideIon::y] = MASSH2O,
[(std::int8_t)Enums::PeptideIon::ystar] = MASSH2O - MASSNH3,
[(std::int8_t)Enums::PeptideIon::yo] = 0,
[(std::int8_t)Enums::PeptideIon::z] = MASSOXYGEN - MASSNITROGEN - MPROTIUM,
[(std::int8_t)Enums::PeptideIon::yp] = -1,
[(std::int8_t)Enums::PeptideIon::x] = MASSCO + MASSOXYGEN}
pappso::Enums::PeptideIon::a
@ a
Nter aldimine ions.
Definition types.h:290
pappso::Enums::PeptideIon::y
@ y
Cter amino ions.
Definition types.h:295
pappso::Enums::PeptideIon::c
@ c
Nter amino ions.
Definition types.h:294
pappso::Enums::PeptideIon::astar
@ astar
Nter aldimine ions + NH3 loss.
Definition types.h:291
pappso::Enums::PeptideIon::bp
@ bp
Definition types.h:293
pappso::Enums::PeptideIon::yp
@ yp
Definition types.h:299
pappso::Enums::PeptideIon::ystar
@ ystar
Cter amino ions + NH3 loss.
Definition types.h:296
pappso::Enums::PeptideIon::yo
@ yo
Cter amino ions + H2O loss.
Definition types.h:297
pappso::Enums::PeptideIon::bstar
@ bstar
Nter acylium ions + NH3 loss.
Definition types.h:288
pappso::Enums::PeptideIon::b
@ b
Nter acylium ions.
Definition types.h:287
pappso::Enums::PeptideIon::x
@ x
Cter acylium ions.
Definition types.h:300
pappso::Enums::PeptideIon::bo
@ bo
Nter acylium ions + H2O loss.
Definition types.h:289
pappso::Enums::PeptideIon::ao
@ ao
Nter aldimine ions + H2O loss.
Definition types.h:292
pappso::Enums::PeptideIon::z
@ z
Cter carbocations.
Definition types.h:298
pappso::MASSCO
const pappso_double MASSCO(MASSCARBON+MASSOXYGEN)
pappso::MPROTIUM
const pappso_double MPROTIUM(1.007825032241)
pappso::MASSH2O
const pappso_double MASSH2O((MPROTIUM *2)+MASSOXYGEN)
pappso::MASSNH3
const pappso_double MASSNH3((MPROTIUM *3)+MASSNITROGEN)
pappso::MASSNITROGEN
const pappso_double MASSNITROGEN(14.0030740048)
pappso::MASSOXYGEN
const pappso_double MASSOXYGEN(15.99491461956)

Definition at line 64 of file peptiderawfragmentmasses.h.

Referenced by getDeltaMass(), pushBackIonMasses(), and pushBackIonMz().

The documentation for this class was generated from the following files:

- pappsomspp/core/peptide/peptiderawfragmentmasses.h
- pappsomspp/core/peptide/peptiderawfragmentmasses.cpp